<?php

namespace Invite\Src;

use Dever;
use Invite\Lib\Relation;

class Api
{
	# 获取邀请码
	public function code($uid)
	{	
    	$info = Dever::db('invite/code')->one(array('uid' => $uid, 'clear' => true));
    	if ($info) {
    		return $info['value'];
    	} else {
    		//$code = Dever::uid($uid);
    		$code = Dever::rand(5, 0);
    		return $this->createCode($uid, $code);
    	}
	}

	private function createCode($uid, $code)
	{
		$info = Dever::db('invite/code')->one(array('value' => $code, 'clear' => true));
		if ($info) {
			$code = Dever::rand(5, 0);
			return $this->createCode($uid, $code);
		} else {
			Dever::db('invite/code')->insert(array('value' => $code, 'uid' => $uid, 'clear' => true));
			return $code;
		}
	}

	# 根据邀请码获取邀请人uid
	public function getUid($code)
	{	
    	$info = Dever::db('invite/code')->one(array('value' => $code, 'clear' => true));
		if ($info) {
			return $info['uid'];
		}
		return false;
	}

	# 直接添加邀请关系
	public function addRelation($uid, $parent, $level = 1)
	{
		$relation = new Relation();
		return $relation->add($parent, $uid, $level);
	}

	# 设置邀请关系
	public function setRelation($uid, $parent = false, $code = false)
	{
		if ($code) {
			$parent = $this->getUid($code);
		}
		if ($parent <= 0) {
			$parent = $this->getSourceUid($uid, false);
			if ($parent <= 0) {
				return false;
			}
		}
		$relation = new Relation();
		$relation->set($parent, $uid);
		return $parent;
	}

	# 更换上级
    public function replaceParent($uid, $old_parent, $new_parent)
    {
        $relation = new Relation();
        return $relation->replaceParent($uid, $old_parent, $new_parent);
    }

    # 重新设置关系
    public function resetRelation($uid, $parent)
    {
        $relation = new Relation();
        return $relation->resetParent($uid, $parent);
    }

	# 删除邀请关系
	public function dropRelation($uid, $parent)
	{
		$relation = new Relation();
		return $relation->dropParent($uid, $parent);
	}

	# 获取某个用户的下级
	public function getChild($uid, $level = false, $page = true)
	{
		$relation = new Relation();
		return $relation->getChild($uid, $level, $page);
	}

    public function getChildNum($uid, $level = false, $start = false, $end = false)
    {
        $relation = new Relation();
        return $relation->getChildNum($uid, $level, $start, $end);
    }

	# 获取某个用户的上级
	public function getParent($uid, $level = 1)
	{
		$relation = new Relation();
		$info = $relation->getParent($uid, $level);
		if ($info) {
			return $info['uid'];
		}
		return false;
	}

    # 获取某个用户的上级
    public function getParentAll($uid, $level = false, $order = 1)
    {
        $relation = new Relation();
        $info = $relation->getParentAll($uid, $level, $order);
        return $info;
    }

	# 获取来源用户uid
	public function getSourceUid($uid, $error = true)
    {
        $source_signature = Dever::input('source_signature');

        if (!$source_signature) {
            if (!$error) {
                return false;
            }
            Dever::alert('错误的来源uid');
        }
        $user = Dever::loginResult($source_signature, false);
        if (!isset($user['uid'])) {
            if (!$error) {
                return false;
            }
            Dever::alert('错误的来源uid');
        }

        $source_uid = $user['uid'];

        if ($uid == $source_uid) {
        	if (!$error) {
        		return false;
        	}
            Dever::alert('来源uid和当前uid相同');
        }

        return $source_uid;
    }

    # 获取两人之间的直推关系
    public function getRelation($uid, $parent_uid)
    {
    	if ($parent_uid == $uid) {
    		return $uid;
    	}
    	$data['uid'] = $parent_uid;
        $data['to_uid'] = $uid;

        $info = Dever::db('invite/relation')->one($data);
        if ($info) {
        	if ($info['level'] == 1) {
        		return $info['to_uid'];
        	}
        	$where['level'] = $info['level'] - 1;
        	$where['to_uid'] = $uid;
        	$info = Dever::db('invite/relation')->one($where);
        	if ($info) {
        		return $info['uid'];
        	}
        }
        return false;
    }
}
